#----------------------------------------------------------------------------------------------------
#Author: Warren Jacobus
#        3065044
#        Univeristy of the Western Cape
#----------------------------------------------------------------------------------------------------
#----------------------------------------------------------------------------------------------------
#Description (display.py):
#           Contains methods used to display:
#           feasible-links,
#           distances,
#           free space loss, and
#           link margins in a tabular fashion
#Inputs:
#           None.
#Outputs:
#           None.
#Caveats:
#           Described below
#----------------------------------------------------------------------------------------------------
#----------------------------------------------------------------------------------------------------
#Feasible:
#            Displays the feasible links in a graph in tabular fashion.           
#Inputs:
#            Set of feasible links.
#Outputs:
#            Table showing feasible links between nodes in a graph.
#Caveats:
#            feasible links list is required to be a list of 3-tuples.
#----------------------------------------------------------------------------------------------------
def Feasible(feasible_links): # print table of feasible links
   print "FEASIBLE LINKS"
   if len(feasible_links) != 0:
      feasible_links.sort()
      if len(feasible_links) == 1:
         print "%s"%(str(feasible[0]))
         #print "\033[1m%s\033[0m"%(str(feasible[0]))
      else:
         for i in range(0,len(feasible_links)-1,2):
            print "(%s,%s,%.2f) \t\t------------------------->\t\t "%(feasible_links[i]),
            print "(%s,%s,%.2f)"%(feasible_links[i+1])
            #print "\033[1m(%s,%s,%.2f)\033[0m\t\t------------------------->\t\t"%(feasible_links[i]),
            #print "\033[1m(%s,%s,%.2f)\033[0m"%(feasible_links[i+1])
   else:
      print "None"
      #print "\033[1mNone\033[0m"
   print
#----------------------------------------------------------------------------------------------------
#Distance:
#            Displays the distances between nodes in a graph in tabular fashion.
#Inputs:
#            2d-array/list containing distance between each node in a graph           
#Outputs:
#            Table showing distances between nodes in a graph.
#Caveats:
#            distances list is required to be a 2d-array/list.
#----------------------------------------------------------------------------------------------------
def Distances(distances): # print table of distances between each location
   print "\nDISTANCES"
   for i in xrange(len(distances)):
      for j in xrange(len(distances[0])):
         if i == 0  or j == 0:
            print "%s \t"%distances[i][j],
         else:
            print "%.2f \t"%(distances[i][j]),
            #print "\033[1m%.2f\033[0m\t"%(distances[i][j]),
      print
   print
#----------------------------------------------------------------------------------------------------
#FreeSpaceLoss:
#            Displays the free space loss between nodes in a graph in tabular fashion.
#Inputs:
#            2d-array/list containing the free space loss between each node in a graph           
#Outputs:
#            Table showing the free space loss between nodes in a graph.
#Caveats:
#            lfs list is required to be a 2d-array/list.
#----------------------------------------------------------------------------------------------------
def FreeSpaceLoss(lfs): # print table of free space loss between each node
   print "FREE SPACE LOSS"
   for i in xrange(len(lfs)):
      for j in xrange(len(lfs[0])):
         if i == 0 or j == 0:
            print "%s \t"%lfs[i][j],
         else:
            print "%.2f \t"%(lfs[i][j]),
            #print "\033[1m%.2f\033[0m\t"%(lfs[i][j]),
      print
   print
#----------------------------------------------------------------------------------------------------
#LinkMargins:
#            Displays the link margins between nodes in a graph in tabular fashion.
#Inputs:
#            2d-array/list containing the link margins between each node in a graph           
#Outputs:
#            Table showing the link margins between nodes in a graph.
#Caveats:
#            link_margins list is required to be a 2d-array/list.
#----------------------------------------------------------------------------------------------------
def LinkMargins(link_margins): # print table of link margins
   print "LINK MARGINS"
   for i in xrange(len(link_margins)):
      for j in xrange(len(link_margins[0])):
         if i == 0 or j == 0:
            print "%s \t"%link_margins[i][j],
         else:
            print "%.2f \t"%(link_margins[i][j]),
            #print "\033[1m%.2f\033[0m\t"%(link_margins[i][j]),
      print
   print
#----------------------------------------------------------------------------------------------------
#END
#----------------------------------------------------------------------------------------------------
